package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayNature;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayPayeeAisleAddBo;
import com.zhongzheng.modules.pay.bo.PayPayeeAisleQueryBo;
import com.zhongzheng.modules.pay.bo.PayPayeeAisleEditBo;
import com.zhongzheng.modules.pay.domain.PayPayeeAisle;
import com.zhongzheng.modules.pay.mapper.PayPayeeAisleMapper;
import com.zhongzheng.modules.pay.vo.PayPayeeAisleVo;
import com.zhongzheng.modules.pay.service.IPayPayeeAisleService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 收款方账户Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayPayeeAisleServiceImpl extends ServiceImpl<PayPayeeAisleMapper, PayPayeeAisle> implements IPayPayeeAisleService {

    @Override
    public PayPayeeAisleVo queryById(Long accountId){
        PayPayeeAisleQueryBo payPayeeAisleQueryBo = new PayPayeeAisleQueryBo();
        payPayeeAisleQueryBo.setAccountId(accountId);
        Collection<PayPayeeAisleVo> payPayeeAisleVos = baseMapper.queryList(payPayeeAisleQueryBo);
        return BeanUtil.toBean(entity2Vo(payPayeeAisleVos).get(0), PayPayeeAisleVo.class);
    }

    @Override
    public List<PayPayeeAisleVo> queryList(PayPayeeAisleQueryBo bo) {
        return entity2Vo(baseMapper.queryList(bo));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayPayeeAisleVo> entity2Vo(Collection<PayPayeeAisleVo> collection) {
        List<PayPayeeAisleVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayPayeeAisleVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayPayeeAisleVo> page = (Page<PayPayeeAisleVo>)collection;
            Page<PayPayeeAisleVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayPayeeAisleAddBo bo) {
        PayPayeeAisle add = BeanUtil.toBean(bo, PayPayeeAisle.class);
        LambdaQueryWrapper<PayPayeeAisle> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPayeeAccount()), PayPayeeAisle::getPayeeAccount, bo.getPayeeAccount());
        List<Integer> status = new ArrayList<>();
        status.add(1);
        status.add(0);
        lqw.in(bo.getStatus() != null, PayPayeeAisle::getStatus, status);
        List<PayPayeeAisle> list = this.list(lqw);
        if (CollectionUtils.isNotEmpty(list)){
            throw new RuntimeException("重复收款方账户名字");
        }
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayPayeeAisleEditBo bo) {
        PayPayeeAisle update = BeanUtil.toBean(bo, PayPayeeAisle.class);
        LambdaQueryWrapper<PayPayeeAisle> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPayeeAccount()), PayPayeeAisle::getPayeeAccount, bo.getPayeeAccount());
        lqw.like(bo.getAccountId()!= null, PayPayeeAisle::getAccountId, bo.getAccountId());
        List<PayPayeeAisle> list = this.list(lqw);
        if (CollectionUtils.isEmpty(list)){
            lqw.clear();
            lqw.eq(StrUtil.isNotBlank(bo.getPayeeAccount()), PayPayeeAisle::getPayeeAccount, bo.getPayeeAccount());
            List<Integer> status = new ArrayList<>();
            status.add(1);
            status.add(0);
            lqw.in(bo.getStatus() != null, PayPayeeAisle::getStatus, status);
            List<PayPayeeAisle> list1 = this.list(lqw);
            if (CollectionUtils.isNotEmpty(list1)){
                throw new IllegalArgumentException("重复收款方账户名字");
            }
        }
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayPayeeAisle entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
